Loading...
Searching...
No Matches
dolfin::SubMesh Class Reference

`#include <SubMesh.h>`

Inheritance diagram for dolfin::SubMesh:
[legend]
Collaboration diagram for dolfin::SubMesh:
[legend]

## Public Member Functions

| SubMesh (const Mesh &mesh, const SubDomain &sub_domain)
| Create subset of given mesh marked by sub domain.
| SubMesh (const Mesh &mesh, const MeshFunction< std::size_t > &sub_domains, std::size_t sub_domain)
| Create subset of given mesh marked by mesh function.
| SubMesh (const Mesh &mesh, std::size_t sub_domain)
| Create subset of given mesh from stored MeshValueCollection.
| ~SubMesh ()
| Destructor.
Public Member Functions inherited from dolfin::Mesh
| Mesh ()
| Create empty mesh.
| Mesh (MPI_Comm comm)
| Create empty mesh.
| Mesh (const Mesh &mesh)
| Mesh (std::string filename)
| Mesh (MPI_Comm comm, std::string filename)
| Mesh (MPI_Comm comm, LocalMeshData &local_mesh_data)
| ~Mesh ()
| Destructor.
const Mesh & | operator= (const Mesh &mesh)
std::size_t | num_vertices () const
std::size_t | num_edges () const
std::size_t | num_faces () const
std::size_t | num_facets () const
std::size_t | num_cells () const
std::size_t | num_entities (std::size_t d) const
std::vector< double > & | coordinates ()
const std::vector< double > & | coordinates () const
const std::vector< unsigned int > & | cells () const
std::size_t | num_entities_global (std::size_t dim) const
MeshTopology & | topology ()
const MeshTopology & | topology () const
MeshGeometry & | geometry ()
const MeshGeometry & | geometry () const
MeshDomains & | domains ()
const MeshDomains & | domains () const
std::shared_ptr< BoundingBoxTree > | bounding_box_tree () const
MeshData & | data ()
const MeshData & | data () const
CellType & | type ()
const CellType & | type () const
| Get mesh cell type (const version).
std::size_t | init (std::size_t dim) const
void | init (std::size_t d0, std::size_t d1) const
void | init () const
| Compute all entities and connectivity.
void | init_global (std::size_t dim) const
| Compute global indices for entity dimension dim.
void | clean ()
void | order ()
bool | ordered () const
Mesh | renumber_by_color () const
void | scale (double factor)
void | translate (const Point &point)
void | rotate (double angle, std::size_t axis=2)
void | rotate (double angle, std::size_t axis, const Point &point)
void | smooth (std::size_t num_iterations=1)
void | smooth_boundary (std::size_t num_iterations=1, bool harmonic_smoothing=true)
void | snap_boundary (const SubDomain &sub_domain, bool harmonic_smoothing=true)
const std::vector< std::size_t > & | color (std::string coloring_type) const
const std::vector< std::size_t > & | color (std::vector< std::size_t > coloring_type) const
double | hmin () const
double | hmax () const
double | rmin () const
double | rmax () const
std::size_t | hash () const
std::string | str (bool verbose) const
const std::vector< int > & | cell_orientations () const
void | init_cell_orientations (const Expression &global_normal)
MPI_Comm | mpi_comm () const
std::string | ghost_mode () const
void | build_mapping (std::shared_ptr< const Mesh > other) const
Public Member Functions inherited from dolfin::Variable
| Variable ()
| Create unnamed variable.
| Variable (const std::string name, const std::string label)
| Create variable with given name and label.
| Variable (const Variable &variable)
| Copy constructor.
virtual | ~Variable ()
| Destructor.
const Variable & | operator= (const Variable &variable)
| Assignment operator.
void | rename (const std::string name, const std::string label)
| Rename variable.
std::string | name () const
| Return name.
std::string | label () const
| Return label (description).
std::size_t | id () const
Public Member Functions inherited from dolfin::Hierarchical< Mesh >
| Hierarchical (Mesh &self)
| Constructor.
virtual | ~Hierarchical ()
| Destructor.
std::size_t | depth () const
bool | has_parent () const
bool | has_child () const
Mesh & | parent ()
std::shared_ptr< Mesh > | parent_shared_ptr ()
Mesh & | child ()
std::shared_ptr< Mesh > | child_shared_ptr ()
Mesh & | root_node ()
std::shared_ptr< Mesh > | root_node_shared_ptr ()
Mesh & | leaf_node ()
std::shared_ptr< Mesh > | leaf_node_shared_ptr ()
void | set_parent (std::shared_ptr< Mesh > parent)
| Set parent.
void | clear_child ()
| Clear child.
void | set_child (std::shared_ptr< Mesh > child)
| Set child.
const Hierarchical & | operator= (const Hierarchical &hierarchical)
| Assignment operator.
void | _debug () const
| Function useful for debugging the hierarchy.

## Additional Inherited Members

Public Attributes inherited from dolfin::Variable
Parameters | parameters
| Parameters.

## Detailed Description

A SubMesh is a mesh defined as a subset of a given mesh. It provides a convenient way to create matching meshes for multiphysics applications by creating meshes for subdomains as subsets of a single global mesh. A mapping from the vertices of the sub mesh to the vertices of the parent mesh is stored as the mesh data named "parent_vertex_indices".

The documentation for this class was generated from the following files:

- /build/dolfin-lFBzDh/dolfin-2019.2.0~legacy20240219.1c52e83/dolfin/mesh/SubMesh.h
- /build/dolfin-lFBzDh/dolfin-2019.2.0~legacy20240219.1c52e83/dolfin/mesh/SubMesh.cpp